; #########################################################################
; File:       Dialog6_4.asm
; #########################################################################
      .586                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################
      include \masm32\include\windows.inc
      
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      
      include  \masm32\include\comctl32.inc         ; Para InitCommonControls
;..............................................      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      
      includelib  \MASM32\lib\comctl32.lib          ; Para InitCommonControls
; #########################################################################

;include \GeneSys\macros\macros.asm
include \masm32\macros\macros.asm

WinMain     proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc     proto :DWORD,:DWORD,:DWORD,:DWORD
DlgProc     proto :DWORD,:DWORD,:DWORD,:DWORD 
MsgHook     proto :DWORD,:DWORD,:DWORD
       
; #########################################################################
; defined in resource file
;
IDM_Dlg1       equ 1000
IDM_Close      equ 2000

IDC_Nome       equ 12000
IDC_Morada     equ 12001

IDC_TxtNome    equ 11000
IDC_TxtMorada  equ 11001

IDC_Exit       equ 13000
IDC_Cancela    equ 13001
; ##############################################################################################
.data
align 4
_MenuName       db "DIALOG1", 0                 ; definido em rsrc.rc
align 4
_DefDialog1     db "DefDialog1",0               ; definido em rsrc.r
;...............................................
align 4
_ClassName      db "Class_1", 0
align 4
_DisplayName    db "Dialog 6_4", 0
align 4
_CommandLine    dd 0
_hWnd           dd 0
_hInstance      dd 0
;....................................................
align 4
_Name           db 28 dup (?)
                db 0
align 4                
_Address        db 28 dup (?)
                db 0
;----------------------------------------------------
; handles of Edit Boxes and button Segue
;
_hIDC_Nome      dd 0
_hIDC_Morada    dd 0
_hIDC_Exit      dd 0

_hHook          dd 0
_fIgnore        dd 0

_hWndDlg        dd 0        ; to test

;......... Strings to Test .............
align 4
_TestName       db 'Test Window', 0
align 4
_TestCase1      db 'Caso 1', 0
align 4
_TestCase2      db 'Caso 2', 0
align 4
_TestCase3      db 'Caso 3', 0
align 4
_TestCase4      db 'Caso 4', 0
align 4
_TestCase5      db 'Caso 5', 0
; ##############################################################################################
.code
; -----------------------------------------------------------------------
start:          invoke GetModuleHandle, NULL 
                mov    _hInstance, eax

                invoke GetCommandLine        
                mov    _CommandLine, eax

                call     InitCommonControls

                invoke   WinMain, _hInstance, NULL, _CommandLine, SW_SHOWDEFAULT    
                invoke   ExitProcess, eax       
; #########################################################################
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        push  hInst
;        push    _hInstance
	  pop   wc.hInstance
        
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszClassName,  offset _ClassName   ; window class name
        mov wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        
        invoke LoadCursor, NULL, IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        NULL
        mov wc.hIcon,          NULL        

        invoke RegisterClassEx, ADDR wc            ; register the window class

        ; ==================================
        ; Create the main application window
        ; ==================================
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDWINDOW,
                              140, 100, 500, 350,
                              NULL,NULL,
                              hInst,NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ##############################################################################################
WndProc         proc    hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, uMsg
                mov     edx, wParam
                ;
                cmp     eax, WM_COMMAND
                jne     _WM_CLOSE
                ;
                ;================== menu commands ===========================
                cmp     edx, IDM_Dlg1
                jne     _IDM_Close

		    invoke   DialogBoxParam, _hInstance, addr _DefDialog1, hWin,     
                                         offset DlgProc, NULL
                jmp     _eWndProc
                        
_IDM_Close:     cmp     edx, IDM_Close
                jne     _eWndProc
                ;
                invoke   SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
                jmp     _eWndProc
                ;
                ;================= end menu commands ==========================
; 
_WM_CLOSE:      cmp     eax, WM_CLOSE
                je      @F
; 
_WM_DESTROY:    cmp     eax, WM_DESTROY
                jne     _eWndProc
                ;
@@:             invoke  PostQuitMessage, NULL
                mov     eax, 0 
                ret
; 
_eWndProc::     invoke  DefWindowProc, hWin, uMsg, wParam, lParam
                ret
WndProc         endp
; ##############################################################################################
DlgProc     proc     hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

            mov      eax, hWnd
            mov     _hWndDlg, eax

            ;mov      _fIgnore, 0            

                        
	     .if iMsg==WM_INITDIALOG

            ; ------------------------
            ; Set text into edit boxes
            ; ------------------------
		invoke SetDlgItemText, hWnd, IDC_Nome, offset _Name
		invoke SetDlgItemText, hWnd, IDC_Morada, offset _Address

            ; -------------------------------------------------
            ; Get the handles of each edit box and button Segue
            ; -------------------------------------------------
            invoke GetDlgItem, hWnd, IDC_Nome
            mov    _hIDC_Nome, eax
            invoke GetDlgItem, hWnd, IDC_Morada
            mov    _hIDC_Morada, eax
            invoke GetDlgItem, hWnd, IDC_Exit
            mov    _hIDC_Exit, eax

            ;------------------------------------------------
            ; Install a WH_MSGFILTER hook so our MsgHook
            ; callback can intercept the dialog's messages.
            ;------------------------------------------------
            invoke   GetCurrentThreadId
            invoke   SetWindowsHookEx, WH_MSGFILTER, ADDR MsgHook, 0, eax

            ; ----------------------------------------
            ; Set Keyboard Focus at the first Edit Box
            ; ----------------------------------------
		invoke   GetDlgItem, hWnd, IDC_Nome
		invoke   SetFocus, eax

	     .elseif iMsg==WM_CLOSE

            invoke   UnhookWindowsHookEx, _hHook

                ;#################################################################
                ;invoke  MessageBox, _hWndDlg, ADDR _TestCase5, ADDR _TestName, MB_OK
                ;#################################################################

            invoke   EndDialog, hWnd, NULL
            ;mov      _fIgnore, 0            
;.................................................
	     .elseif  iMsg==WM_COMMAND
            ; 
            ; with or without BN_CLIKED it works the same
            ; 
		mov     eax, wParam
            ;mov     edx, eax
		;shr     edx,16                         ; edx =notification code
        	;	.if edx==BN_CLICKED
                        ;
                        and     eax, 0FFFFh         ; eax= control ID
	       		.if eax==IDC_Exit

                              .if _fIgnore == 1
                                  mov   _fIgnore, 0
                              .else

                              invoke GetDlgItemText, hWnd, IDC_Nome, addr _Name, 28+1
				      invoke GetDlgItemText, hWnd, IDC_Morada, addr _Address, 28+1
                              ;
                              invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL                              

                ;#################################################################
                ;invoke  MessageBox, _hWndDlg, ADDR _TestCase3, ADDR _TestName, MB_OK
                ;#################################################################
                              .endif
                              ;                              
        			.elseif eax==IDC_Cancela        
                              ;
                              invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL

                ;#################################################################
                ;invoke  MessageBox, _hWndDlg, ADDR _TestCase4, ADDR _TestName, MB_OK
                ;#################################################################
                              
			     .endif
		      ;.endif
	      .else
		mov   eax, FALSE
		ret
        	.endif
            ;
	      mov  eax, TRUE
	      ret
DlgProc     endp
; 
;MSG STRUCT
;  hwnd      DWORD      ?       ; CONTROL handle
;  message   DWORD      ?       ; Message send
;  wParam    DWORD      ?       ; key pressed
;  lParam    DWORD      ?       ; Pointer to MSG struct
;  time      DWORD      ?
;  pt        POINT      <>
;MSG ENDS

MsgHook         proc    code:DWORD, wParam:DWORD, lParam:DWORD
                push    ebx

                mov     eax, code 
                cmp     eax, MSGF_DIALOGBOX
                jne     _eMsgHook
                ;
                  mov       ebx, lParam
                  
                  mov       eax, [ebx].MSG.message 
                  cmp       eax, WM_KEYDOWN
                  jne       _eMsgHook

                  mov       eax, [ebx].MSG.wParam 
                  cmp       eax, VK_RETURN
                  jne       _eMsgHook
                    ;
                    invoke  GetFocus
                
                    cmp     eax, _hIDC_Nome                     ; First Edit
                    jne     @F
                    ; 
                    invoke  SetFocus, _hIDC_Morada
                    ;                    
                    jmp     _eMsgHook
                    ;
@@:                 cmp     eax, _hIDC_Morada                   ; Second Edit
                    jne     @F
;.........................................................................

                    mov     _fIgnore, 1

              ;--------------------------------------------------
              ; Make button C the default button by forcing the
              ; style to BS_DEFPUSHBUTTON. To avoid disturbing
              ; the other style bits, this code gets the current
              ; value, sets bit0, and then writes the value back.
              ; By changing the OR to an XOR this same code can
              ; be use to force the style to BS_PUSHBUTTON.
              ;--------------------------------------------------
                    invoke GetWindowLong, _hIDC_Exit, GWL_STYLE
                    or     eax, 1
                    ;xor    eax, 1
                    invoke SetWindowLong, _hIDC_Exit, GWL_STYLE, eax

                    ;---------------------------------------------
                    ; Add the button to the update region so it's
                    ; appearance will be updated to match the new
                    ; style on the next paint.
                    ;---------------------------------------------
                    invoke InvalidateRgn, _hIDC_Exit, NULL, FALSE
;.......................................................................
                    invoke  SetFocus, _hIDC_Exit

                ;#################################################################
                ;invoke  MessageBox, _hWndDlg, ADDR _TestCase2, ADDR _TestName, MB_OK
                ;#################################################################
                       
                    jmp     _eMsgHook
                    ;
@@:                 cmp     eax, _hIDC_Exit                         ; First PushButton
                    jne     _eMsgHook

                ;#################################################################
                ;invoke  MessageBox, _hWndDlg, ADDR _TestCase1, ADDR _TestName, MB_OK
                ;#################################################################
            
_eMsgHook:      pop ebx
                ;-----------------------------------------
                ; Return whatever CallNextHookEx returns.
                ;-----------------------------------------

                invoke  CallNextHookEx, _hHook, code, wParam, lParam
                ret
MsgHook         endp
; #########################################
end start
